VERSION 5.00
Begin VB.Form frmMain 
   AutoRedraw      =   -1  'True
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Gradient Fill"
   ClientHeight    =   5625
   ClientLeft      =   45
   ClientTop       =   360
   ClientWidth     =   7275
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   375
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   485
   StartUpPosition =   2  'CenterScreen
   Begin VB.CheckBox chkFill 
      Caption         =   "Fill while drawing"
      Height          =   255
      Left            =   5580
      TabIndex        =   7
      Top             =   1020
      Width           =   1515
   End
   Begin VB.CommandButton cmdRepeat 
      Caption         =   "&Repeat"
      Height          =   375
      Left            =   5580
      TabIndex        =   6
      Top             =   1920
      Width           =   1455
   End
   Begin VB.CheckBox chkErase 
      Caption         =   "Erase old circles"
      Height          =   255
      Left            =   5580
      TabIndex        =   5
      Top             =   660
      Value           =   1  'Checked
      Width           =   1455
   End
   Begin VB.CheckBox chkDisplay 
      Caption         =   "Show tick count"
      Height          =   315
      Left            =   5580
      TabIndex        =   4
      Top             =   240
      Width           =   1455
   End
   Begin VB.Frame Frame1 
      Height          =   45
      Left            =   5580
      TabIndex        =   3
      Top             =   1680
      Width           =   1455
   End
   Begin VB.CommandButton cmdClear 
      Caption         =   "&Clear area"
      Height          =   375
      Left            =   5580
      TabIndex        =   2
      Top             =   2400
      Width           =   1455
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "&Exit"
      Height          =   375
      Left            =   5580
      TabIndex        =   1
      Top             =   2880
      Width           =   1455
   End
   Begin VB.PictureBox picMain 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      Height          =   5220
      Left            =   180
      MousePointer    =   2  'Cross
      ScaleHeight     =   348
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   348
      TabIndex        =   0
      Top             =   240
      Width           =   5220
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Gradient fill example
'by Darko Stanimirovic
'http://darkowebsite.topcities.com/

'check my website for some more VB stuff
'if you have anything you'd like to publish to my website, contact me
'on darko_st20@yahoo.com
Option Explicit

'This is used to move our start point to specific place
Private Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, Lppoint As POINTAPI) As Long
'use this to count time spent in drawing
Private Declare Function GetTickCount Lib "kernel32" () As Long

Private Type POINTAPI
    X As Long
    Y As Long
End Type

'UDT which will hold our color values
Private Type color
    r As Long
    g As Long
    b As Long
End Type

'color variables and timer variables
Dim BeginColor As color, EndColor As color, StartTick As Single, EndTick As Single
'just a temp, we will just fill it with zeros ;)
Dim Lppoint As POINTAPI
'we will need to know what value to add to each color value in for...next loop
Dim Rlevel As Single, Glevel As Single, Blevel As Single
'radius of drawing rectangle
Dim radius As Single
'start and end coordinates of drawing rectangle
Dim EndX As Single, EndY As Single, rctStartX As Single, rctStartY As Single
'boolean to check if we are drawing rectangle and string to keep information about rectangle direction (see it later)
Dim drawRect As Boolean, TypeString As String

Private Sub chkFill_Click()
If chkFill.Value = 1 Then chkDisplay.Enabled = False Else chkDisplay.Enabled = True
End Sub

Private Sub cmdClear_Click()
picMain.Cls
End Sub

Private Sub cmdExit_Click()
    Unload Me
End Sub

Private Sub DrawFill(Optional ShowInfo As Boolean = True)

Dim tt As Long
MoveToEx picMain.hdc, 0, 0, Lppoint
StartTick = GetTickCount()
picMain.DrawWidth = 2

'Begin gradient fill
    For tt = 0 To radius
        picMain.ForeColor = RGB(BeginColor.r + tt * Rlevel, BeginColor.g + tt * Glevel, BeginColor.b + tt * Blevel)
        picMain.Circle (rctStartX, rctStartY), tt
    Next tt

picMain.Refresh

EndTick = GetTickCount()
'if user decided to view tick count, it will be shown
If ShowInfo And chkDisplay Then MsgBox "Operation took " & EndTick - StartTick & " miliseconds", vbInformation, "Testing"

End Sub

Private Sub cmdRepeat_Click()
DrawFill
End Sub

Private Sub Form_Load()

Show
'just fill them with zeros, no use of it anyway
Lppoint.X = 0
Lppoint.Y = 0

'Good place to change Start and End colors ;)
BeginColor.r = 0
BeginColor.g = 17
BeginColor.b = 40

EndColor.r = 255
EndColor.g = 255
EndColor.b = 255

End Sub

Private Sub picMain_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
'initiate drawing of rectangle
If Not drawRect Then
    drawRect = True
    'remember start coords
    rctStartX = X
    rctStartY = Y
'or cancel it
Else
    drawRect = False
    'remember end coords
    EndX = X
    EndY = Y
    DrawFill
End If

End Sub

Private Sub picMain_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

If drawRect Then
    'clear previous drawings
    If chkErase Then picMain.Cls

    'if radius or pHeight are zero, just skip the error
    On Error Resume Next
    'determine levels again every time mouse moves
    'since radius is changing constantly
    Rlevel = Abs((EndColor.r - BeginColor.r) / radius)
    Glevel = Abs((EndColor.g - BeginColor.g) / radius)
    Blevel = Abs((EndColor.b - BeginColor.b) / radius)

    'determine rectangle dimensions
    If X > rctStartX Then radius = X - rctStartX Else radius = rctStartX - X
    'If Y > rctStartY Then pheight = Y - rctStartY Else pheight = rctStartY - Y
    If radius = 0 Then radius = 1

    'drawing circle's border color
    picMain.ForeColor = RGB(255, 0, 0)
    picMain.DrawWidth = 1
    picMain.Circle (rctStartX, rctStartY), radius
    
    If chkFill Then DrawFill
End If

End Sub
